/**
 *  JustAjaxTable, version 0.7 Beta
 *  (c) 2007 JustAjaxTable.com
 *
 *  Type: Uncompressed
 */

/////////////// Table ///////////////////////////////////////

/**
 * Interface for (X)HTML-Table.
 * 
 * @author JustAjax.com
 * @param parent parent for table
 * @param width table width (cells)
 * @param height table height (cells)
 * @param property array with property
 */
function Table()
{
  /**
   * Initializing
   *
   * @author JustAjax.com
   */
  this._init = function()
  {
    if ( arguments[0][0] && arguments[0][0].tagName && arguments[0][0].tagName == 'TABLE' )
    {
      this.me = arguments[0][0];
    }
    else
    {
      // create table
      this.create( arguments[0][0],  ( arguments[0][1] ) ? arguments[0][1] : 1, ( arguments[0][2] ) ? arguments[0][2] : null, ( arguments[0][3] ) ? arguments[0][3] : null );
    }
  }
  
  /**
   * Sort Number (for sort method)
   *
   * @return number
   * @param a
   * @param b
   */
  function sortNumber(a, b)
  {
    a = a.substr( 0, a.lastIndexOf('~') );
    b = b.substr( 0, b.lastIndexOf('~') );
    return a - b;
  }
  
  /**
   * Sort Table
   *
   * @param row row of table
   * @param type ( 0 - for string, 1 - for number )
   */
  this.sort = function( row )
  {
    var table  = this.lines( 0, this.me.getElementsByTagName('TR').length ).get();
    var atable = [];
    
    // convert
    for (var j = 0; j < table.length; j++) 
    {
      for (var i = 0; i < table[j].length; i++) 
      {
        if (!atable[i]) atable[i] = [];
        atable[i][j] = table[j][i] + (( i == row ) ? '~' + j : '');
      }
    }
    
    // select of type sort
    if ( arguments[1] )
      atable[ row ].sort(sortNumber);
    else
      atable[ row ].sort();
    
    var word = [];
    var index = [];
    
    // adapter
    for (var j = 0; j < atable[ row ].length; j++) 
    {
      var delimiter = atable[ row ][j].lastIndexOf('~');
      word.push(atable[ row ][j].substr(0,delimiter));
      index.push(atable[ row ][j].substr(delimiter+1));
    }
    
    var table = [];
    
    // unconvert
    for (var j = 0; j < atable.length; j++) 
    {
      for (var i = 0; i < atable[j].length; i++) 
      {
        if (!table[i]) table[i] = [];
        if (j == row)
        {
          table[i].push(word[i]);
        }
        else
        {  
          table[i].push(atable[ j ][index[i]]);
        }
      }
    }
        
    for (var i = 0; i < table.length; i++) 
      this.lines( 0, this.me.getElementsByTagName('TR').length ).set( table );
  }
  
  /**
   * Create Table
   *
   * @param parent parent for table
   * @param width table width (cells)
   * @param height table height (cells)
   * @param property array with property
   */
  this.create = function( _parent, _width, _height, _property )
  {
    this.me   = this.createElement( _parent, 'table', ( typeof(_width) == 'object' ) ? _height : _property, '' );
    var tbody = this.createElement( this.me, 'tbody', {}, '' );
    if ( typeof(_width) == 'object' )
    {
      for (var i = 0; i < _width.length; i++)
      {
        var tr = this.createElement( tbody, 'tr', {}, '');
        if ( typeof(_width[i][ _width[i].length - 1 ]) != 'object'  )  _width[i].push({});
        for (var j = 0; j < _width[i].length - 1; j++)
        {
          this.createElement( tr, 'td', ( _width[i][ _width[i].length - 1 ][j] ) ? _width[i][ _width[i].length - 1 ][j] : {}, _width[i][j].toString() );
        } 
      }
    }
    else
    {  
      for (var i = 0; i < _width; i++)
      {
        var tr = this.createElement( tbody, 'tr', {}, '');
        for (var j = 0; j < _height; j++)
        {
          this.createElement( tr, 'td', {}, '');
        } 
      }
    }
  }
  
  /**
   * Cell Object
   *
   * @return object
   * @param x coordinate x
   * @param y coordinate y
   */
  this.cells = function()
  {
    // retrun <TR>
    if ( arguments[1] == null && this.me.getElementsByTagName('TR')[ arguments[0] ] ) return this.me.getElementsByTagName('TR')[ arguments[0] ];
    if ( this.me.getElementsByTagName('TR')[ arguments[1] ] && this.me.getElementsByTagName('TR')[ arguments[1] ].getElementsByTagName('TD')[ arguments[0] ] )
    {
      var cell = this.me.getElementsByTagName('TR')[ arguments[1] ].getElementsByTagName('TD')[ arguments[0] ];
      return {
         
         // link on object
         me   : cell,
         // get
         get  : function(){ return cell.innerHTML },
         // set
         set  : function( data ){ cell.innerHTML = data; }, 
         // clear
         clear: function(){ cell.innerHTML = ''; }
         
      };
    } 
    return {};
  }

  /**
   * Lines Object
   *
   * @return object
   * @param start start
   * @param amount amount
   */
  this.lines = function()
  {
    if (arguments[1])
    {
      var start  = arguments[0];
      var amount = arguments[1];
    }
    else
    {
      var start  = arguments[0];
      var amount = 1;
    }
    
    var self = this;
      
    if ( this.me.getElementsByTagName('TR')[ start ] )
    {
      return {         
        // get line
        get  : function(){ 
            
          var results = [];
          var _id     = 0;
          var lines;
          
          for (var j = start; j < start + amount; j++)
          {
            results[_id] = [];
            
            lines = self.me.getElementsByTagName('TR')[ j ];
            
            if (lines.getElementsByTagName('TD'))
            {
              
              for (var i = 0; i < lines.getElementsByTagName('TD').length; i++)
              {
                results[_id].push(lines.getElementsByTagName('TD')[i].innerHTML);
              }
            
            }
            
            _id++;
            
           }
          
          return results;
          
        },
        // set table
        set  : function( _array ){ 
            
          var _id  = 0;
          var lines;
          var type = (arguments[1]) ? true : false;
          var adding = (type && arguments[2]) ? true : false;
          
          for (var j = start; j < start + amount; j++)
          {
            lines = self.me.getElementsByTagName('TR')[ j ];
            
            if (lines.getElementsByTagName('TD'))
            {
              
              for (var i = 0; i < lines.getElementsByTagName('TD').length; i++)
              {
                if ( _array[_id] && _array[_id][i])
                {
                  lines.getElementsByTagName('TD')[i].innerHTML = _array[_id][i];
                }
                else if( type )
                {
                  lines.getElementsByTagName('TD')[i].innerHTML = (adding) ? arguments[2] : '';
                }  
              }
            }
            _id++;            
           }
          
        },
        // set table
        clear  : function(){ 
            
          var lines;
          
          for (var j = start; j < start + amount; j++)
          {
            lines = self.me.getElementsByTagName('TR')[ j ];
            
            if (lines.getElementsByTagName('TD'))
            {
              
              for (var i = 0; i < lines.getElementsByTagName('TD').length; i++)
              {
                lines.getElementsByTagName('TD')[i].innerHTML = '';
              }
            
            }
            
          }
          
        },
        // delete lines
        'delete' : function( _array ){ 
            
          for (var j = start; j < start + amount; j++)
          {
            if ( self.me.getElementsByTagName('TR')[ start ] )
            {
             self.removeElement( self.me.getElementsByTagName('TR')[ start ] );
            }
          }
          
        },
        // add lines
        add  : function(){ 
          var lines, content = '';
          var _array = (arguments[0]) ? arguments[0] : [];
          var table = (self.me.getElementsByTagName('TBODY')) ? self.me.getElementsByTagName('TBODY')[0] : self.me;
          var count = table.getElementsByTagName('TR')[ 0 ].getElementsByTagName('TD').length;
          var el2 = (table.getElementsByTagName('TR')[ start + 1 ]) ? table.getElementsByTagName('TR')[ start + 1 ] : null;
          for (var j = 0; j < amount; j++)
          {
             var el = document.createElement('TR');
             for (var i = 0; i < count; i++)
             {
               self.createElement( el, 'TD', {}, (_array[j] && _array[j][i]) ? _array[j][i] : '' );
             }
             table.insertBefore( el, el2 );
             el2 = el;
          }
        },
        // link on object
        me : this.me.getElementsByTagName('TR')[ start ]
      }
    }
    return {};
  }
  
  ///// DOM ///////////
 
 /**
  * Remove Element 
  *
  * @author crossbrowserajax.com
  * @param _element dom-element
  * @member cbaDOM
  */
  this.removeElement = function(_element)
  {
    _element.parentNode.removeChild(_element);
  }
  
  /**
   * Create Element
   *
   * @author crossbrowserajax.com
   * @return link on element
   * @param _parent parent for element
   * @param _type type of element (tag name)
   * @param _property assotiative array for property. Example: { 'className' : 'my-class' , 'style.color' : '#f00' }. 
   * Warning: support only one-level & two-level parameters (one-level - 'className' or two-level - 'style.color')
   * @param _text tag content (any text)
   * @member cbaDOM
   */
  this.createElement = function( _parent, _type, _property, _text )
  {
    // create element
    var el = document.createElement(_type);
    // set all properties
    for (var k in _property) 
    {
      var keys = k.split('.');
      // if 'k' - object
      if (keys.length == 2)
      {
        el[keys[0]][keys[1]] = _property[k];
      }
      else
      {
        el[k] = _property[k];
      }  
    }
    // add text in the tag
    if (_text != '') el.innerHTML = _text;
    // add in a parent
    _parent.appendChild(el);
    // link on element
    return el;
   }
  
  /** Init Class */
  this._init( arguments );
}


/////////////// justAjaxTable ///////////////////////////////

/**
 * Just Ajax Table
 * 
 * @author JustAjax.com
 * @param parent parent for table ( id )
 */
function justAjaxTable()
{

  /**
   * Initializing
   *
   * @author JustAjax.com
   */
  this._init = function()
  {
    
    // create parent
    this.parent = new Table( document.getElementById( arguments[0][0] ) );
    this.dom = this.parent;
    
    // main table title
    this.table_title = this.parent.me.getElementsByTagName('TABLE')[0];
    
    // main table
    this.table  = new Table( this.parent.me.getElementsByTagName('TABLE')[1] );
    
    // get lines
    this.table_lines = this.table.me.getElementsByTagName('TR').length;
    // get width
    this.table_width = this.table.me.getElementsByTagName('TR')[0].getElementsByTagName('TD').length;
    
    // this max length for cell
    this._max_length_cell = 30;
    
    // edit enable
    this._edit_enable = true;
    
    // create CBA object (unless exists)
    if (!_cba) _cba = new cbaRequest();
    
    // id table status
    this._table_status         = 'just-table-status';
    
    // error ajax update message
    this._error_update_message = 'Error!\n';
    
    // url query for update
    this._url_update           = arguments[0][1];
    // url auto table update
    this._url_scroll           = arguments[0][2];
    // cache size
    this._cache_size           = arguments[0][3];
    
    // lines amount
    this._count_lines          = arguments[0][4];
    
    // background image for updates
    this._img_background       = arguments[0][5];
    
    // frequency of the renovation ( milliseconds )
    this._frequency_renovation = 1000;
    
    // scroll position
    this._old_sroll_top = 0;
    
    this._cache = {};
    
    var self = this;
    
    
    if ( this._edit_enable )
    {
      // set event for cells ( for edit )
      for (var i = 0; i < this.table_lines; i++)
      {
        for (var j = 0; j < this.table_width; j++)
        {
          this.table.cells(j,i).me.onclick    = function(){ self.editCell(this); };
        }
      }
    }
    
    // addings for titles
    this._down_sort = '<sup style="position:absolute;margin:7px 0px 0px 2px;font-size:9px;font-weight:normal;color:#aaa;"> down</sup>';
    this._up_sort   = '<sup style="position:absolute;margin:-2px 0px 0px 2px;font-size:9px;font-weight:normal;color:#aaa;"> up</sup>';
    
    // create scroll
    this.createScroll();
    
    this.createLiveTitles();
    
    // load new data
    this.scrollAction( this.main_div, true );
    
  }
  
  /**
   * Click on Title
   *
   * @param _title object
   */
  this.titleClickAction = function( _title )
  {
    var self = this;
    
    // normalization
    if ( this.column_sort )
    {
      this.column_sort.innerHTML = this._default_val;
    }
    
    this._default_val = _title.innerHTML;
    
    // direction of the sorting
    if ( this.column_sort == _title && this._sort_directions )
    {
      this._sort_directions = 0;
      _title.innerHTML += this._up_sort;
    }
    else
    {
      this._sort_directions = 1;
      _title.innerHTML += this._down_sort;
    }
    
    this.column_sort  = _title;
    
    var _column = this.table_title.getElementsByTagName('TR')[0];
    
    // read title
    for ( var i = 0; i < this.table_width; i++ )
    {
      if ( _column.getElementsByTagName('TH')[ i ] == _title )
      {
        this._select_title = i;
        break;
      }
    }
    
   // delete timer
   if ( this.cache_sort_timer ) clearTimeout( this.cache_sort_timer );
   
   // update table
   this.cache_sort_timer = setTimeout( function(){ self._cache = {}; self.scrollAction( self.main_div, true ); }, this._frequency_renovation );
    
    
  }
  
  /**
   * Create Live Titles ( for sorting )
   */
  this.createLiveTitles = function()
  {
    // default values
    this.column_sort  = null;
    this._default_val = "";
    this._sort_directions = 0;
    this._select_title = null;
    
    var self    = this;
    var _column = this.table_title.getElementsByTagName('TR')[0];
    
    // read title
    for ( var i = 0; i < this.table_width; i++ )
    {
      // styles
      _column.getElementsByTagName('TH')[ i ].style.cursor = 'pointer';
      // actions
      _column.getElementsByTagName('TH')[ i ].onclick = function() {
        self.titleClickAction( this );
      };
    }
  }
  
  /**
   * Update Status
   * 
   * @param type boolean (true - loading, false - ready)
   * @param cell cell object ( unnecessary parameter )
   */
  this.ajaxUpdateStatus = function ( type )
  {
    var _cell_style = ( arguments[1] ) ? arguments[1] : this.current_cell.me.style;
    with ( _cell_style )
    {
      if ( type ) // set status
      {
        backgroundColor    = '#fffff2';
        backgroundImage    = this._img_background;
        backgroundRepeat   = 'no-repeat';
        backgroundPosition = 'right';
      }
      else // clear status
      {
        background         = 'none';
      }
    }
  }
 
  /**
   * Clear Status Renovations
   */
  this.clearStatusRenovations = function ( )
  {
    // search cell in Table
    for (var i = 0; i < this.table_lines; i++)
    {
      for (var j = 0; j < this.table_width; j++)
      {
        // clear
        this.ajaxUpdateStatus( false, this.table.cells(j,i).me.style );        
      }
    }
  }
  
  /**
   * Remote Update
   * 
   * @param _value new value
   */
  this.ajaxUpdate = function ( _value  )
  {
    // create request
    var query = [];
    var self    = this;
    for ( var i = 0; i < this.table_width; i++ )
    {
      query.push( this._cache[this._old_position + this.current_cell.x][i] );
    }
    query = {
       'position' : this.current_cell.y,
       'value'    : _value,
       'signs'    : query
    };
    // update table status
    this.ajaxUpdateStatus( true );
    
    // parameters save
    var _current_cell = this.current_cell;
    
    // query
    // document.getElementById('statuss').innerHTML = this.packGetQuery( self._url_update, query );
    
    // send query
    _cba.query( this.packGetQuery( self._url_update, query ), function(){
      
      // parameters reconstruction
      self.current_cell = _current_cell;
      
      // ready status
      self.ajaxUpdateStatus( false );
          
      if ( _cba.answer == true )
      {
        // update cache
        self._cache[self.current_cell.offset + self.current_cell.x][self.current_cell.y] = _value;
        
        // update cell
        var _offset = self.current_cell.x - ( self._old_position - self.current_cell.offset );
        if ( _offset < self.table_lines && _offset >= 0 )
        {
          self.table.cells(self.current_cell.y, _offset).set( ( self._max_length_cell && _value.length && _value.length > self._max_length_cell ) ? _value.substr(0,self._max_length_cell) + '...' : _value );
        }
        
        // adaptes scroll height
        self.adaptesScrollHeight();    
      }
      else
      {
        // error in update
        alert( self._error_update_message + _cba.answer );
      }
        
    } );
  }
  
  /**
   * Pack Query
   * 
   * @return full url-query
   * @param _url url-address
   * @param query object with parameters
   */
  this.packGetQuery = function ( _url, query )
  {
    var url_query = '';
    for (var key in query)
    {
      if (typeof(query[key]) == 'string' || typeof(query[key]) == 'number' || typeof(query[key]) == 'boolean') // for simple data
      {
        url_query += key + '=' + query[key] + '&';
      }
      else if (query[key] instanceof Array) // for array ( univariate )
      {
        for (var i = 0; i < query[key].length; i++)
        {
          url_query += key + '[]=' + query[key][i] + '&';
        }
      }
    }
    return _url + ( ( _url.indexOf('?') > -1 ) ? '&' : '?' ) + url_query.substr(0,url_query.length - 1);
  }
  
  /**
   * Update Cache and Cell
   * 
   * @param _value new value
   */
  this.updateCell = function ( _value  )
  {
    // conditions of the renovation ( if cell changed  )
    if ( this._cache[this._old_position + this.current_cell.x] && this._cache[this._old_position + this.current_cell.x][this.current_cell.y] != _value )
    {
      // update cache
      this.ajaxUpdate( _value  );
    }
  }
  
  /**
   * Editor Show For Cell
   * 
   * @param cell cell object in table
   * @param _y
   * @param _x
   */
  this.editorShow = function ( cell, _y, _x )
  {
    var self        = this;
    var textBoxId   = "justEditorShowTextBox";
    var parentleft  = 0;
    var parenttop   = 0;
    var _offsetleft = -5;
    var _offsettop  = -5;
    
    var _z_index    = 1000;
    var _width      = 250;
    var _height     = 50;
    
    // get parent coordinate
    for ( var parent = cell.offsetParent; parent; parent = parent.offsetParent )
    {
      parentleft += parent.offsetLeft;
      parenttop  += parent.offsetTop;
    }
    
    if ( !this.cellEditor )
    {
      var cell_editor_bg_property = {
        'style.position'  : 'absolute',
        'style.filter'    : 'alpha(style=0,opacity=20)',
        'style.MozOpacity': '.20',
        'style.background': '#777',
        'style.zIndex'    : _z_index - 1,
        'style.width'     : _width + 'px',
        'style.height'    : _height + 'px',
        'style.top'       : ( parenttop  + cell.offsetTop + _offsettop + 4 )  + 'px',
        'style.left'      : ( parentleft + cell.offsetLeft + _offsetleft - 2 ) + 'px'
      };
      this.cellEditorBg = this.dom.createElement( document.body,   'div', cell_editor_bg_property, '' );
      
      var cell_editor_property = {
        'style.position'  : 'absolute',
        'style.border'    : '1px solid #999',
        'style.background': '#fff',
        'style.zIndex'    : _z_index,
        'style.width'     : _width + 'px',
        'style.height'    : _height + 'px',
        'style.top'       : ( parenttop  + cell.offsetTop + _offsettop )  + 'px',
        'style.left'      : ( parentleft + cell.offsetLeft + _offsetleft ) + 'px'
      };
      this.cellEditor = this.dom.createElement( document.body,   'div', cell_editor_property, '' );
      
      // content box
      var cell_box_property = {
        onmouseout    : function()
        {
          self.cellEditor.style.display   = 'none';
          self.cellEditorBg.style.display = 'none';
          self.updateCell( this.value );
        },
        'id'          : textBoxId,
        'style.border': '0px',
        'style.overflow' : 'auto',
        'style.width' : _width + 'px',
        'style.height': _height - 1 + 'px'
      };
      this.dom.createElement( this.cellEditor, 'textarea', cell_box_property, '' );
    }
    else
    {
      this.cellEditor.style.top      = parenttop  + cell.offsetTop + _offsettop  + 'px';
      this.cellEditor.style.left     = parentleft + cell.offsetLeft + _offsetleft + 'px';
      this.cellEditor.style.display  = 'block';
      
      this.cellEditorBg.style.top      = parenttop  + cell.offsetTop + _offsettop  + 4 + 'px';
      this.cellEditorBg.style.left     = parentleft + cell.offsetLeft + _offsetleft - 2 + 'px';
      this.cellEditorBg.style.display  = 'block';      
    }
    document.getElementById( textBoxId ).value = this._cache[this._old_position + _x][_y];
    document.getElementById( textBoxId ).focus();
  }
  
  /**
   * Edit Cell
   * 
   * @param cell cell object in table
   */
  this.editCell = function ( cell )
  {
    if ( this._edit_enable )
    {
      // search cell in Table
      var i, j, _break;
      for (i = 0; i < this.table_lines; i++)
      {
        for (j = 0; j < this.table_width; j++)
        {
          if (this.table.cells(j,i).me == cell)
          {
            _break = true;
            break;
          }
        }
        if (_break) break;
      }
      // check cache
      if ( this._cache[this._old_position + i] )
      {
        // save position
        this.current_cell = {
          'me'     : cell,
          'x'      : i,
          'y'      : j,
          'offset' : this._old_position 
        };
        this.editorShow( cell, j, i );
      }
    }
  }
  
  /**
   * Cache Update ( for scrolling )
   * 
   * @param start
   */
  this.cacheAjaxUpdate = function( start )
  {
    var self = this;
    
    var i; var count = start - Math.round( this._cache_size / 2 );
    
    // check keys
    for ( i = start - 1; i > count && i >= 0; i-- )
    {
      if ( this._cache[ i ] ) break;
    }
    
    if ( count > 0 )
    {
      var _count = this._cache_size - ( Math.round( this._cache_size / 2 ) - ( start - i ) );
      var _start = i;
    }
    else
    {
      var _count = this._cache_size;
      var _start = 0;
    }
    
    var query = {
      
      'start' : _start,
      'count' : _count
      
    };
    
    // if user sorting
    if ( this._select_title != null )
    {
      query['directions'] = this._sort_directions;
      query['column'] = this._select_title;
    }
    
    // status write
    // document.getElementById('statuss').innerHTML = '<br/> <b>request:</b> ' + this.packGetQuery( this._url_scroll, query ) + '<br/><br/> <b>this._cache:</b> ' + this._cache.toSource();
    
    
    // send query
    _cba.query( this.packGetQuery( this._url_scroll, query ), function(){
      
      
      var counter = _cba.answer[1].length - 1;
      
      // delete old values
      for (var key in self._cache)
      {
        if ( !counter-- || key == start ) break;
        // clear old keys
        delete( self._cache[ key ] );
      }
      
      // update cache
      for (var i = 0; i < _cba.answer[1].length; i++)
      {
        self._cache[ _cba.answer[0] + i ] = _cba.answer[1][i];
      }
      
      self.updateTable( self._old_position, self.table_lines );
        
    } );
  }
  
  /**
   * Update Table
   * 
   * @param start start for update
   * @param count count
   */
  this.updateTable = function( start, count )
  {
    var _narr = [];
    var _arr  = [];
    var _zero = false;
   
    // slice
    for (var i = start; i < start + count; i++)
    {
      if ( this._cache[i] )
      {
        _arr.push( this._cache[i] );
      }
      else
      {
        if ( _zero === false ) _zero = i;
        var spaces = [];
        for (var j = 0; j < this.table_width; j++) spaces.push( '&nbsp;' );
        _arr.push( spaces );
      }
    }
   
    var self = this;
   
    // delete timer
    if ( this.cache_update_timer ) clearTimeout( this.cache_update_timer );
   
    // update table
    if ( _zero !== false ) this.cache_update_timer = setTimeout( function(){ self.cacheAjaxUpdate( _zero ); }, this._frequency_renovation );
        
    // length limit
    if ( this._max_length_cell )
    {
      for (var i = 0; i < _arr.length; i++)
      {
        _narr[i] = [];
        for (var j = 0; j < _arr[i].length; j++)
        {
          if ( _arr[i][j].length && _arr[i][j].length > this._max_length_cell )
          {
            _narr[i][j] = _arr[i][j].substr(0,this._max_length_cell) + '...';
          }
          else
          {
            _narr[i][j] = ( _arr[i][j] != '' ) ? _arr[i][j] : '&nbsp;';
          }
        } 
      }
      this.table.lines( 0, count ).set( _narr );
    }
    else
    {
      this.table.lines( 0, count ).set( _arr );
    }
    
    // adaptes scroll height
    this.adaptesScrollHeight();
  }
  
  /**
   * Scroll Event
   * 
   * @param scroller object
   */
  this.scrollAction = function( scroller )
  {
    var const_normalize = ( this._count_lines > 10000 ) ? 0.01 : 0.001;
    var bit  = scroller.scrollTop * 100 / scroller.scrollHeight;
    var step = Math.ceil( bit * (this._count_lines - this.table_lines) / 100 );
    
    if ( scroller.scrollTop < this._old_sroll_top ) 
    {
      scroller.scrollTop = ( ( step - const_normalize ) - 1 ) * scroller.scrollHeight / ( this._count_lines - this.table_lines );
    }
    else
    {
      scroller.scrollTop = ( step - const_normalize ) * scroller.scrollHeight / ( this._count_lines - this.table_lines );
    }
    
    
    if ( this._old_position != step || arguments[1] )
    {
      // clear status update
      if ( this._edit_enable ) this.clearStatusRenovations();
      
      this.updateTable( step, this.table_lines );
      // update of status
      if ( document.getElementById( this._table_status ) ) document.getElementById( this._table_status ).innerHTML = 'amount: ' + this._count_lines + '; display: ' + ( step + 1 ) + ' - ' + (step + this.table_lines);
      this._old_position  = step;
      // adaptes scroll height
      this.adaptesScrollHeight();
    }
    
    this._old_sroll_top = scroller.scrollTop;
  }
  
  /**
   * Adaptes Scroll Height
   *
   */
  this.adaptesScrollHeight = function()
  {
    this.main_div.style.height = this.table.me.offsetHeight + 'px';
  }
  
  /**
   * Create Scroll
   * 
   * @param _parent parent
   */
  this.createScroll = function()
  {
    var self = this;
        
    var scroll_main_top     = this.parent.cells(0,0).me.offsetHeight;  
    var scroll_main_height  = this.parent.me.offsetHeight - scroll_main_top;
    
    this.cell_height        = this.table.cells(0,0).me.offsetHeight;
    
    var scroll_child_height = this._count_lines * this.cell_height * 10;
    
    
    // event for scrolling
    var scroll_action = function(){ self.scrollAction( this ); };
    
    // property
    var main_div_property  = {
       'onscroll'          : scroll_action,
       'onmousemove'       : scroll_action,
       'onclick'           : scroll_action,
       'style.borderRight' : '1px solid rgb(171, 171, 171)',
       'style.marginTop'   : scroll_main_top + 'px',
       'style.left'        : '-3px',
       'style.overflow'    : 'auto',
       'style.position'    : 'relative',
       'style.width'       : '19px',
       'style.height'      : scroll_main_height + 'px'
    };
    var child_div_property = {
       'style.width'       : '1px',
       'style.height'      : scroll_child_height + 'px'
    };    
    
    // create
    this.main_div  = this.dom.createElement( this.parent.cells(1,0).me, 'div', main_div_property, '' );    
    this.child_div = this.dom.createElement( this.main_div, 'div', child_div_property, '' );
    
    // control position
    this._old_position = 0;
    
    // set position
    this.adaptesScrollHeight();
    
    this.scroller = {
        
      'height' : this.child_div.style.height
        
    };
        
  }
  
  /** Init Class */
  this._init( arguments );
  
}