<?php




/*!
 * just Table Class
 *
 * \author JustAjax.com
 */
class justTable
{
  //@{
    /*! Table Name */
    var $_table = '';
    /*! Table columns */
    var $_columns = array();
  //@}  
  
  /*!
   * Init
   *
   * \param $table table name
   * \param $columns array with columns names
   */
  function justTable( $table, &$columns )
  {
    // set table name
    $this -> _table   = $table;
    // set columns names
    $this -> _columns = $columns;
  }
  
  /*!
   * Cell Update Status
   *
   * \return javascriptresponse for C.B.A. library
   * \param $cba_query_id cba query id
   * \param $message return 'true' or error message
   */
  function CellUpdateStatus( $cba_query_id, $message )
  {
    // template
    $template = '
    
     _cba.ready (
      %id%,
      %status%
     ); 
    
    ';
    
    if ( $message === true )
    {
      $message = 'true';
    }
    else
    {
      $message = '"'.addslashes($message).'"';
    }
    
    $template = str_replace('%id%', $cba_query_id, $template);
    $template = str_replace('%status%', $message, $template);
    
    return $template;    
  }
  
  /*!
   * Update Cell
   * 
   * \param $val_news new value
   * \param $val_index index
   * \param $type_check index type of the check
   * \param $values values
   */
  function UpdateCell( $val_news, $val_index, $type_check, &$values )
  {
    $sql = '
    UPDATE
      '.$this -> _table.'
    SET
      '.$this -> _columns[ $val_index ].' = "'.addslashes( $val_news ).'"  
    ';
    
    // type
    if ( $type_check == -1 )
    {
      $start = 0;
      $stop  = count( $this -> _columns );
    }
    else
    {
      $start = $type_check;
      $stop  = $start + 1;
    }
    
    $sql .= ' WHERE ';
    
    // check previous importances
    for ( $i = $start; $i < $stop; $i++ )
    {
      $sql .= ' '.$this -> _columns[ $i ].' = "'.addslashes( $values[ $i ] ).'",';
    }
    
    $sql = substr($sql, 0, -1).' LIMIT 1';
    
    @mysql_query( $sql );
    
  }
  
  /*!
   * Read Table
   *
   * \return array
   * \param int $start start
   * \param int $count count
   * \param int $sort number column
   * \param int $direction direction for sorting
   */
  function read( $start, $count, $sort, $direction = 0 )
  {
    $result = array();
    
    // shaping the direction of the sorting
    $direction = ( $direction ) ? 'ASC' : 'DESC';
    
    // sql-query
    $sql = '
    SELECT
      '.join( $this -> _columns, ', ' ).'
    FROM
      '.$this -> _table.'  
    ORDER BY
      '.$this -> _columns[$sort].' '.$direction.'
    LIMIT
      '.$start.', '.$count;
    
    // query
    $query  = @mysql_query( $sql );
    
    if ( $query )
    {
      while ( $rows = mysql_fetch_row($query) )
      {
        // save in array
        $result[] = $rows;
      }
    }
    
    return $result;
  }
  
  /*!
   * Special Convertor from PHP-array to JavaScript-array
   * 
   * \return js-array
   * \param $array php-array
   */
  function justPhpArrayToJsArray( &$array )
  {
    $result = '';
    
    $count = count($array);
    
    $result .= "\r\n[\r\n";
    
    for ($i = 0; $i < $count; $i++)
    {
      $result .= " [";
      
      for ($j = 0; $j < count( $array[$i] ); $j++)
      {
        $result .= '"'.addslashes($array[$i][$j]).'"'.(( $j == count( $array[$i] ) - 1 ) ? '' : ',' );
      } 
    
      $result .= "],\r\n";
    }
    
    // delete comma
    $result  = substr( $result, 0, -3 );
      
    $result .= "\r\n]\r\n";
    
    return $result;
  }
 
  /*!
   * Is Sql-Injection Attack
   *
   * \return boolean
   * \param $string string
   */ 
   function isSqlInjectionAttack( $string )
   {
     if ( preg_match( '!char\(|char\s+\(!i', $string ) ) return true;
     return false;
   }
 
  /*!
   * Check Type
   * 
   * \return boolean
   * \param $value value
   * \param $type type
   * \param $limit limit
   */
   function checkType( $value, $type, $limit )
   {
     if ( $type == 'int' )
     {
      if ( !preg_match( '!^[0-9]{0,'.$limit.'}$!', $value  ) ) return 1; // is not integer or excess of the limit
     }
     elseif ( $type == 'string' )
     {
      if ( $this -> isSqlInjectionAttack( $value ) || strlen( $value ) > $limit ) return 2; // possible attack sql-injection or excess of the limit
     }
     else
     {
      return 0; // unknown type 
     }
     
     return true;
   }
  
 /*!
  * Check Variables
  *
  * \return type error or true
  * \param $vars_attributes possible attributes
  * \param $vars previous importances
  * \param $var_new_value new value
  * \param $var_index index for new value
  * \param $type type of the check
  */  
  function checkVariables( $vars_attributes, $vars, $var_new_value, $var_index, $type = -1 )
  {
    $count = count( $vars_attributes );
    
    // type
    if ( $type == -1 )
    {
      $start = 0;
      $stop  = $count;
    }
    else
    {
      $start = $type;
      $stop  = $start + 1;
    }
    
    // check previous importances
    for ( $i = $start; $i < $stop; $i++ )
    {
      if ( $this -> checkType( $vars[ $i ], $vars_attributes[ $i ][0], $vars_attributes[ $i ][1] ) !== true ) return 'Incorrect data!';
    }
    
    // it is impossible edit
    if ( !$vars_attributes[ $var_index ][2] ) return 'It is impossible edit!';
    
    // mismatch of the types or invalid length
    if ( $this -> checkType( $var_new_value, $vars_attributes[ $var_index ][0], $vars_attributes[ $var_index ][1] ) !== true ) return 'Mismatch of the types or invalid length!';
    
    return true;
  }
  
  /*!
   * Special Response Cba Pack
   *
   * \return response ( javascript-code ) for C.B.A. library
   * \param $cba_query_id cba query id
   * \param $start start value
   * \param $response response ( javascript-object )
   */   
  function justResponseCbaPack( $cba_query_id, $start, &$response )
  {
    // template
    $template = '
    
     _cba.ready (
      %id%,
      [
        %start%,
        %data%
      ]
     ); 
    
    ';
    
    $template = str_replace('%id%', $cba_query_id, $template);
    $template = str_replace('%start%', $start, $template);
    $template = str_replace('%data%', $response, $template);
    
    return $template;
        
  }
 
  
}
?>